--- u-boot-2011.06_original/board/cavium/cnc1900/power_clock.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/board/cavium/cnc1900/power_clock.c	2015-05-18 19:41:06.764203000 +0800
@@ -0,0 +1,1692 @@
+/****************************************************************************
+  * Copyright (C) 2011 Cavium Inc.
+  * All rights reserved
+  *
+  * [RELEASE HISTORY]                           
+  * VERSION  DATE       AUTHOR                  DESCRIPTION
+  * 0.1      11-10-10       Jia Ma           		Original
+  ****************************************************************************
+*/
+
+#include <linux/types.h>
+#include <common.h>
+#include <asm/byteorder.h>
+#include <malloc.h>
+#include "cnc_util.h"
+#include "power_clock.h"
+
+#define df_clk_write(a,v) (*(volatile unsigned int*)(a) = (v))
+#define df_clk_read(a)    (*(volatile unsigned int*)(a))
+#if 0
+typedef struct _DISP_PLL_CFG_
+{
+  DISP_CLOCK_MODE mode;
+  double          frequency;
+  unsigned int    tve_sys_divider;
+  unsigned int    tve_m;
+  unsigned int    tve_fb;
+}DISP_PLL_CFG;
+#endif 
+#define power_clk_base CNC1900_ID_SCS
+#define power_clk_write(a,v) (*(volatile unsigned int*)(power_clk_base+((a)&0xfff)) = (v))
+#define power_clk_read(a)    (*(volatile unsigned int*)(power_clk_base+((a)&0xfff)))
+#if 0
+static DISP_PLL_CFG disp_pll_cfg[] = {
+	{_YUV_NTSC                   , 27000000  , 7  , 4  , 15} , 
+	{_YUV_PAL                    , 27000000  , 7  , 4  , 15} , 
+	{_YUV_480P                   , 27000000  , 7  , 4  , 15} , 
+	{_YUV_576P                   , 27000000  , 7  , 4  , 15} , 
+	{_YUV_720P_50Hz              , 74250000  , 0  , 2  , 21} , 
+	{_YUV_720P_60Hz              , 74250000  , 0  , 2  , 21} , 
+	{_YUV_1080I_50Hz             , 74250000  , 0  , 2  , 21} , 
+	{_YUV_1080I_60Hz             , 74250000  , 0  , 2  , 21} , 
+	{_YUV_1080I_50Hz_1250_Total  , 72000000  , 0  , 0  , 0}  , 
+	{_YUV_1080P_24Hz             , 74250000  , 0  , 2  , 21} , 
+	{_YUV_1080P_25Hz             , 74250000  , 0  , 2  , 21} , 
+	{_YUV_1080P_30Hz             , 74250000  , 0  , 2  , 21} , 
+	{_YUV_1080P_50Hz             , 148500000 , 0  , 2  , 21} , 
+	{_YUV_1080P_60Hz             , 148500000 , 0  , 2  , 21} , 
+	{_RGB_DMT_640x350_85Hz       , 31500000  , 12 , 9  , 20} , 
+	{_RGB_DMT_640x400_85Hz       , 31500000  , 12 , 9  , 20} , 
+	{_RGB_DMT_720x400_85Hz       , 35500000  , 0  , 8  , 20} , 
+	{_RGB_DMT_640x480_60Hz       , 25175000  , 15 , 15 , 27} , 
+	{_RGB_DMT_640x480_72Hz       , 31500000  , 12 , 9  , 20} , 
+	{_RGB_DMT_640x480_75Hz       , 31500000  , 12 , 9  , 20} , 
+	{_RGB_DMT_640x480_85Hz       , 36000000  , 0  , 6  , 15} , 
+	{_RGB_DMT_800x600_56Hz       , 36000000  , 0  , 6  , 15} , 
+	{_RGB_DMT_800x600_60Hz       , 40000000  , 0  , 0  , 0}  , 
+	{_RGB_DMT_800x600_72Hz       , 50000000  , 0  , 7  , 25} , 
+	{_RGB_DMT_800x600_75Hz       , 49500000  , 0  , 6  , 21} , 
+	{_RGB_DMT_800x600_85Hz       , 56250000  , 0  , 6  , 24} , 
+	{_RGB_DMT_848x480_60Hz       , 33750000  , 0  , 6  , 14} , 
+	{_RGB_DMT_1024x768_43Hz      , 44900000  , 0  , 6  , 19} , 
+	{_RGB_DMT_1024x768_60Hz      , 65000000  , 0  , 5  , 23} , 
+	{_RGB_DMT_1024x768_70Hz      , 75000000  , 0  , 0  , 0}  , 
+	{_RGB_DMT_1024x768_75Hz      , 78750000  , 0  , 5  , 28} , 
+	{_RGB_DMT_1024x768_85Hz      , 94500000  , 4  , 3  , 20} , 
+	{_RGB_DMT_1152x864_75Hz      , 108000000 , 0  , 2  , 15} , 
+	{_RGB_DMT_1280x768_60Hz_RED  , 68250000  , 0  , 0  , 0}  , 
+	{_RGB_DMT_1280x768_60Hz      , 79500000  , 0  , 0  , 0}  , 
+	{_RGB_DMT_1280x768_75Hz      , 102250000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1280x768_85Hz      , 157500000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1280x960_60Hz      , 108000000 , 0  , 2  , 15} , 
+	{_RGB_DMT_1280x960_85Hz      , 148500000 , 0  , 2  , 21} , 
+	{_RGB_DMT_1280x1024_60Hz     , 108000000 , 0  , 2  , 15} , 
+	{_RGB_DMT_1280x1024_75Hz     , 135000000 , 0  , 2  , 19} , 
+	{_RGB_DMT_1280x1024_85Hz     , 157500000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1360x768_60Hz      , 85500000  , 0  , 3  , 18} , 
+	{_RGB_DMT_1400x1050_60Hz_RED , 101000000 , 0  , 2  , 14} , 
+	{_RGB_DMT_1400x1050_60Hz     , 121750000 , 0  , 2  , 17} , 
+	{_RGB_DMT_1400x1050_75Hz     , 156000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1400x1050_85Hz     , 179500000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1440x900_60Hz_RED  , 88750000  , 0  , 0  , 0}  , 
+	{_RGB_DMT_1440x900_60Hz      , 106500000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1440x900_75Hz      , 136750000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1440x900_85Hz      , 157000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1600x1200_60Hz     , 162000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1600x1200_65Hz     , 175500000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1600x1200_70Hz     , 189000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1600x1200_75Hz     , 202500000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1600x1200_85Hz     , 229500000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1680x1050_60Hz_RED , 119000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1680x1050_60Hz     , 146250000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1680x1050_75Hz     , 187000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1680x1050_85Hz     , 214750000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1792x1344_60Hz     , 204750000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1792x1344_75Hz     , 261000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1856x1392_60Hz     , 218250000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1856x1392_75Hz     , 288000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1920x1200_60Hz_RED , 154000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1920x1200_60Hz     , 193250000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1920x1200_75Hz     , 245250000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1920x1200_85Hz     , 281250000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1920x1440_60Hz     , 234000000 , 0  , 0  , 0}  , 
+	{_RGB_DMT_1920x1440_75Hz     , 297000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_640x480_50Hz       , 19750000  , 19 , 13 , 18} , 
+	{_RGB_CVT_640x480_60Hz       , 23875000  , 16 , 13 , 22} , 
+	{_RGB_CVT_640x480_75Hz       , 30625000  , 0  , 11 , 24} , 
+	{_RGB_CVT_640x480_85Hz       , 35625000  , 0  , 11 , 28} , 
+	{_RGB_CVT_800x600_50Hz       , 31125000  , 12 , 10 , 22} , 
+	{_RGB_CVT_800x600_60Hz       , 38125000  , 10 , 6  , 16} , 
+	{_RGB_CVT_800x600_75Hz       , 48875000  , 0  , 8  , 28} , 
+	{_RGB_CVT_800x600_85Hz       , 56500000  , 0  , 5  , 20} , 
+	{_RGB_CVT_1024x768_50Hz      , 51750000  , 0  , 6  , 22} , 
+	{_RGB_CVT_1024x768_60Hz      , 64125000  , 0  , 4  , 18} , 
+	{_RGB_CVT_1024x768_75Hz      , 81750000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1024x768_85Hz      , 94250000  , 4  , 3  , 20} , 
+	{_RGB_CVT_1280x960_50Hz      , 83000000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x960_60Hz      , 102000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x960_75Hz      , 129875000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x960_85Hz      , 149375000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1400x1050_50Hz     , 99750000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1400x1050_60Hz     , 122500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1400x1050_75Hz     , 155875000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1400x1050_85Hz     , 179125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x1200_50Hz     , 132375000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x1200_60Hz     , 160875000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x1200_75Hz     , 205875000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x1200_85Hz     , 234625000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1800x1350_50Hz     , 168250000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1800x1350_60Hz     , 204500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1800x1350_75Hz     , 261250000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1800x1350_85Hz     , 299625000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1536_50Hz     , 218625000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1536_60Hz     , 267000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1536_75Hz     , 340500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1536_85Hz     , 388125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1920_50Hz     , 346000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1920_60Hz     , 421375000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1920_75Hz     , 533750000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1920_85Hz     , 611125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x1024_50Hz     , 89375000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x1024_60Hz     , 108875000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x1024_75Hz     , 138500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x1024_85Hz     , 159375000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_640x360_50Hz       , 14750000  , 26 , 22 , 23} , 
+	{_RGB_CVT_640x360_60Hz       , 17875000  , 21 , 22 , 28} , 
+	{_RGB_CVT_640x360_75Hz       , 22500000  , 17 , 9  , 14} , 
+	{_RGB_CVT_640x360_85Hz       , 25750000  , 0  , 11 , 20} , 
+	{_RGB_CVT_848x480_50Hz       , 26000000  , 0  , 14 , 26} , 
+	{_RGB_CVT_848x480_60Hz       , 31500000  , 12 , 9  , 20} , 
+	{_RGB_CVT_848x480_75Hz       , 40875000  , 0  , 5  , 14} , 
+	{_RGB_CVT_848x480_85Hz       , 47250000  , 8  , 6  , 20} , 
+	{_RGB_CVT_1024x576_50Hz      , 37875000  , 10 , 10 , 27} , 
+	{_RGB_CVT_1024x576_60Hz      , 46875000  , 8  , 6  , 20} , 
+	{_RGB_CVT_1024x576_75Hz      , 60625000  , 0  , 4  , 17} , 
+	{_RGB_CVT_1024x576_85Hz      , 69125000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x720_50Hz      , 60375000  , 0  , 4  , 17} , 
+	{_RGB_CVT_1280x720_60Hz      , 74375000  , 0  , 4  , 21} , 
+	{_RGB_CVT_1280x720_75Hz      , 95625000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x720_85Hz      , 110000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x900_50Hz      , 97000000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x900_60Hz      , 118875000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x900_75Hz      , 152125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x900_85Hz      , 174750000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1920x1080_50Hz     , 141375000 , 0  , 2  , 20} , 
+	{_RGB_CVT_1920x1080_60Hz     , 172750000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1920x1080_75Hz     , 220500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1920x1080_85Hz     , 252875000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1152_50Hz     , 162125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1152_60Hz     , 198000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1152_75Hz     , 252500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1152_85Hz     , 289500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1440_50Hz     , 256000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1440_60Hz     , 311750000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1440_75Hz     , 396750000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1440_85Hz     , 454250000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_640x400_50Hz       , 16375000  , 23 , 14 , 16} , 
+	{_RGB_CVT_640x400_60Hz       , 19875000  , 19 , 19 , 27} , 
+	{_RGB_CVT_640x400_75Hz       , 25000000  , 15 , 14 , 25} , 
+	{_RGB_CVT_640x400_85Hz       , 29125000  , 13 , 13 , 27} , 
+	{_RGB_CVT_768x480_50Hz       , 23625000  , 16 , 12 , 20} , 
+	{_RGB_CVT_768x480_60Hz       , 28625000  , 13 , 8  , 16} , 
+	{_RGB_CVT_768x480_75Hz       , 37250000  , 0  , 8  , 21} , 
+	{_RGB_CVT_768x480_85Hz       , 42500000  , 0  , 7  , 21} , 
+	{_RGB_CVT_1024x640_50Hz      , 42625000  , 0  , 6  , 18} , 
+	{_RGB_CVT_1024x640_60Hz      , 52750000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1024x640_75Hz      , 67375000  , 0  , 3  , 14} , 
+	{_RGB_CVT_1024x640_85Hz      , 77625000  , 0  , 4  , 22} , 
+	{_RGB_CVT_1280x800_50Hz      , 68500000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x800_60Hz      , 83375000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x800_75Hz      , 107250000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x800_85Hz      , 123375000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x1000_50Hz     , 108625000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x1000_60Hz     , 133125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x1000_75Hz     , 169125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x1000_85Hz     , 194125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1920x1200_50Hz     , 158000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1920x1200_60Hz     , 193125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1920x1200_75Hz     , 246500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1920x1200_85Hz     , 282625000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1280_50Hz     , 181125000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1280_60Hz     , 221250000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1280_75Hz     , 280500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1280_85Hz     , 321625000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1600_50Hz     , 285750000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1600_60Hz     , 348000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1600_75Hz     , 442750000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1600_85Hz     , 507000000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_640x480_60Hz_RED   , 22750000  , 0  , 16 , 26} , 
+	{_RGB_CVT_800x600_60Hz_RED   , 34375000  , 11 , 11 , 27} , 
+	{_RGB_CVT_1024x768_60Hz_RED  , 54500000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x960_60Hz_RED  , 83375000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1400x1050_60Hz_RED , 99000000  , 0  , 3  , 21} , 
+	{_RGB_CVT_1600x1200_60Hz_RED , 128000000 , 0  , 2  , 18} , 
+	{_RGB_CVT_1800x1350_60Hz_RED , 160625000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1536_60Hz_RED , 206250000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1920_60Hz_RED , 318500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1280x1024_60Hz_RED , 89000000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_640x360_60Hz_RED   , 17000000  , 22 , 23 , 28} , 
+	{_RGB_CVT_848x480_60Hz_RED   , 28875000  , 13 , 7  , 14} , 
+	{_RGB_CVT_1024x576_60Hz_RED  , 40875000  , 0  , 5  , 14} , 
+	{_RGB_CVT_1280x720_60Hz_RED  , 62500000  , 0  , 5  , 22} , 
+	{_RGB_CVT_1600x900_60Hz_RED  , 96000000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1920x1080_60Hz_RED , 136500000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1152_60Hz_RED , 154625000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1440_60Hz_RED , 238750000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_640x400_60Hz_RED   , 18875000  , 20 , 15 , 20} , 
+	{_RGB_CVT_768x480_60Hz_RED   , 26500000  , 0  , 15 , 28} , 
+	{_RGB_CVT_1024x640_60Hz_RED  , 45500000  , 0  , 8  , 26} , 
+	{_RGB_CVT_1280x800_60Hz_RED  , 69500000  , 0  , 0  , 0}  , 
+	{_RGB_CVT_1600x1000_60Hz_RED , 106625000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_1920x1200_60Hz_RED , 151750000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2048x1280_60Hz_RED , 171875000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_2560x1600_60Hz_RED , 265375000 , 0  , 0  , 0}  , 
+	{_RGB_CVT_800x480_60Hz,295000000,13,11,23},
+	{_RGB_CVT_1366x768_60Hz,70200000,0,5,25},
+};
+#endif
+void clock_disp_reset(DISP_ID ID,CLOCK_RESET ResetOrSet)
+{
+    int reg_val = 0;
+
+    reg_val = df_clk_read(CLOCK_SOFT_RESET);
+
+    if (ResetOrSet==_do_reset) {
+        reg_val = reg_val & ((_disp1) ? 0xffffdfff : 0xffffefff);
+    } else {
+        reg_val = reg_val | ((_disp1) ? 0x2000 : 0x1000);
+    }
+
+    df_clk_write(CLOCK_SOFT_RESET,reg_val);
+
+    return;
+}
+#if 0
+int clock_dispset_clockmode0(DISP_ID ID,DISP_CLOCK_MODE DispName)
+{
+    int rt = 0;
+
+    if (ID == _disp0) {
+        rt = clock_dispset_clockmoderaw(ID,DispName,_tve_pll);
+    } else {
+        rt = clock_dispset_clockmoderaw(ID,DispName,_sys_pll);
+    }
+
+    return (rt);
+}
+
+int clock_dispset_clockmode1(DISP_ID ID,DISP_CLOCK_MODE DispName)
+{
+    int rt = 0;
+
+    if (ID == _disp0) {
+        rt = clock_dispset_clockmoderaw(ID,DispName,_sys_pll);
+    } else {
+        rt = clock_dispset_clockmoderaw(ID,DispName,_tve_pll);
+    }
+
+    return (rt);
+}
+
+int clock_dispset_clockmode2(DISP_ID ID,DISP_CLOCK_MODE DispName)
+{
+    int rt = 0;
+
+    if (ID == _disp0) {
+        rt = clock_dispset_clockmoderaw(ID,DispName,_tve_pll);
+    } else {
+        rt = clock_dispset_clockmoderaw(ID,DispName,_tve_pll);
+    }
+
+    return (rt);
+}
+#endif
+#if 0
+
+static void clock_dispclock_gating(DISP_ID ID)
+{
+    int reg_val = 0;
+
+    //0.1 Disable output
+    if (ID==_disp0) {
+        reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+        df_clk_write(CLOCK_PLL_CLK_EN, reg_val&0xffffffaf);
+    } else {
+        reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+        df_clk_write(CLOCK_PLL_CLK_EN, reg_val&0xffffffdf);
+    }
+
+#if 0
+    //0.2 Gate Clock
+    if (ID==_disp0) {
+        reg_val = df_clk_read(CLOCK_TVE_SEL);
+        df_clk_write(CLOCK_TVE_SEL, reg_val&0xfffffffc);
+    } else {
+        reg_val = df_clk_read(CLOCK_TVE_SEL);
+        df_clk_write(CLOCK_TVE_SEL, reg_val&0xfffcffff);
+    }
+#endif
+    return;
+}
+
+void clock_disptve_pllmode(POWER_MODE PowerMode)
+{
+    unsigned int reg_val = 0;
+
+    if (PowerMode == _clock_wake) {
+        reg_val = df_clk_read(CLOCK_PLL_SLEEP_N);
+        df_clk_write(CLOCK_PLL_SLEEP_N, reg_val|0x1);
+
+        udelay(100);
+
+        reg_val = df_clk_read(CLOCK_PLL_SLEEP_N);
+        df_clk_write(CLOCK_PLL_SLEEP_N, reg_val|0x2);
+    } else {
+        reg_val = df_clk_read(CLOCK_PLL_SLEEP_N);
+        df_clk_write(CLOCK_PLL_SLEEP_N, reg_val&0xfffffffd);
+
+        udelay(10);
+
+        reg_val = df_clk_read(CLOCK_PLL_SLEEP_N);
+        df_clk_write(CLOCK_PLL_SLEEP_N, reg_val&0xfffffffe);
+    }
+
+    return;
+}
+
+void clock_dispsys_pllmode(POWER_MODE PowerMode)
+{
+    //Not Implemented.
+    return;
+}
+
+int clock_dispset_clockmoderaw(DISP_ID ID,DISP_CLOCK_MODE DispName,DISP_CLOCK_SOURCE ClockSource)
+{
+    int IsValid=0;
+    unsigned int reg_val = 0;
+    unsigned int Disp;
+    unsigned int TveClk0;
+    unsigned int TveClk6;
+    unsigned int HdmiTmds;
+    DISP_PLL_CFG *pdisp_pll_cfg=NULL;
+
+    pdisp_pll_cfg=&disp_pll_cfg[DispName];
+
+    //0.Check Valid or not
+    if (ClockSource==_sys_pll) {
+        IsValid = pdisp_pll_cfg->tve_sys_divider !=0;
+    } else {
+        IsValid=((pdisp_pll_cfg->tve_fb!=0) && (pdisp_pll_cfg->tve_m!=0));
+    }
+
+    //1.Config Clock
+    if (IsValid) {
+        //1.0 Gate Clock of Display source
+        clock_dispclock_gating(ID);
+
+        //1.1 Disable Power Down PLL
+        if (ClockSource==_sys_pll) {
+            clock_dispsys_pllmode(_clock_sleep);
+        } else {
+#if 0
+            //gate off DIVM;
+            reg_val = df_clk_read(CLOCK_PLL_TVE_DIV);
+            df_clk_write(CLOCK_PLL_TVE_DIV, reg_val&0xffff7fff);
+#endif
+            udelay(200);
+
+            clock_disptve_pllmode(_clock_sleep);
+        }
+
+	clock_disp_reset(ID, _do_reset);
+
+        //1.3 Config Mux and PLL Parameters
+        //1.3.1 Config the PLL Parameters
+#if 0
+        if (ClockSource == _sys_pll) {
+            reg_val = df_clk_read(CLOCK_CLK_GEN_DIV);
+
+            if (ID==_disp0) {
+                reg_val = ((reg_val&0xffffffe0) | pdisp_pll_cfg->tve_sys_divider);
+            } else {
+                reg_val = ((reg_val&0xffffe0ff) | (pdisp_pll_cfg->tve_sys_divider<<8));
+            }
+
+            df_clk_write(CLOCK_CLK_GEN_DIV, reg_val);
+        } else {
+            reg_val = df_clk_read(CLOCK_PLL_TVE_DIV);
+
+            reg_val = (reg_val&0xffff0000)| pdisp_pll_cfg->tve_m;
+            reg_val = reg_val|(pdisp_pll_cfg->tve_fb <<8);
+            reg_val |= 0x8000;
+
+            df_clk_write(CLOCK_PLL_TVE_DIV, reg_val);
+        }
+#else
+	if(ID==_disp0){
+		reg_val = df_clk_read(CLOCK_PLL_TVE_DIV);
+
+		reg_val = (reg_val&0xffff0000)| pdisp_pll_cfg->tve_m;
+		reg_val = reg_val|(pdisp_pll_cfg->tve_fb <<8);
+		reg_val |= 0x8000;
+
+		df_clk_write(CLOCK_PLL_TVE_DIV, reg_val);
+	}
+	else{
+		reg_val = df_clk_read(CLOCK_CLK_GEN_DIV);
+
+		reg_val = ((reg_val&0xffffe0ff) | (pdisp_pll_cfg->tve_sys_divider<<8));
+
+		df_clk_write(CLOCK_CLK_GEN_DIV, reg_val);
+        }
+#endif
+        //1.3.2 Wait 2us for PLL generating a stable clock
+        udelay(500);
+
+        //1.3.3 PLL Clock Wake
+        if (ClockSource==_sys_pll) {
+            clock_dispsys_pllmode(_clock_wake);
+        } else {
+            clock_disptve_pllmode(_clock_wake);
+        }
+
+        //1.3.4 Config Clock Switcher Level #1
+#if 0
+        reg_val = df_clk_read(CLOCK_TVE_SEL);
+        if (ID==_disp0) {
+            if (ClockSource==_sys_pll) {
+                reg_val = (reg_val & 0xfffffffc)|0x1;
+            } else {
+                reg_val = (reg_val & 0xfffffffc)|0x2;
+            }
+
+        } else {
+            if (ClockSource==_sys_pll) {
+                reg_val = (reg_val & 0xfffcffff)|0x10000;
+            } else {
+                reg_val = (reg_val & 0xfffcffff)|0x20000;
+            }
+        }
+        df_clk_write(CLOCK_TVE_SEL,reg_val);
+#endif
+        //1.3.5 Config Divider
+        reg_val = df_clk_read(CLOCK_TVE_DIV_N);
+        switch (DispName) {
+        case _YUV_NTSC:
+        case _YUV_PAL:
+            Disp  	=4;
+            TveClk0	=2;
+            TveClk6 =4;
+            HdmiTmds=4;
+            break;
+        case _YUV_480P:
+        case _YUV_576P:
+            Disp  	=4;
+            TveClk0	=2;
+            TveClk6 =2;
+            HdmiTmds=4;
+            break;
+        case _YUV_1080I_50Hz:
+        case _YUV_1080I_60Hz:
+        case _YUV_720P_50Hz:
+        case _YUV_720P_60Hz:
+        case _YUV_1080P_24Hz:
+        case _YUV_1080P_25Hz:
+        case _YUV_1080P_30Hz:
+        case _YUV_1080I_50Hz_1250_Total:
+            Disp  	=4;
+            TveClk0	=2;
+            TveClk6 =4;
+            HdmiTmds=4;
+            break;
+        case _YUV_1080P_50Hz:
+        case _YUV_1080P_60Hz:
+            Disp  	=2;
+            TveClk0	=2;
+            TveClk6 =4;
+            HdmiTmds=2;
+            break;
+        default:
+            Disp  	=2;
+            TveClk0	=2;
+            TveClk6 =4;
+            HdmiTmds=2;
+        }
+
+        if (ID==_disp0) {
+            reg_val &= 0xffff0000;
+            reg_val |= (HdmiTmds<<12);
+            reg_val |= (Disp<<8);
+            reg_val |= (TveClk6<<4);
+            reg_val |= TveClk0;
+        } else {
+            reg_val &= 0xf000ffff;
+            reg_val |= (Disp<<24);
+            reg_val |= (TveClk6<<20);
+            reg_val |= (TveClk0<<16);
+        }
+
+        df_clk_write(CLOCK_TVE_DIV_N,reg_val);
+
+	    clock_disp_reset(ID, _do_set);
+
+        //1.3.6 wait 1 us for stable
+        udelay(50);//?
+
+        //1.3.7 Enable
+        reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+
+        if (ID==_disp0) {
+            reg_val |= 0x50;
+        } else {
+            reg_val |= 0x20;
+        }
+
+        df_clk_write(CLOCK_PLL_CLK_EN, reg_val);
+    } 
+	else {
+       	return (-1); 
+    }
+
+    return (0);
+}
+
+
+void clock_dispset_dac0mode(POWER_MODE PowerMode)
+{
+    unsigned int reg_val = 0;
+
+    reg_val = df_clk_read(CLOCK_DAC_POWER_DOWN);
+
+    if (PowerMode==_clock_sleep) {
+        reg_val |= 0x7;
+    } else {
+        reg_val &= 0xfffffff8;
+    }
+
+    df_clk_write(CLOCK_DAC_POWER_DOWN, reg_val);
+
+    return;
+}
+
+void clock_dispset_dac1mode(POWER_MODE PowerMode)
+{
+    unsigned int reg_val = 0;
+
+    reg_val = df_clk_read(CLOCK_DAC_POWER_DOWN);
+
+    if (PowerMode==_clock_sleep) {
+        reg_val |= 0x38;
+    } else {
+        reg_val &= 0xffffffc7;
+    }
+
+    df_clk_write(CLOCK_DAC_POWER_DOWN, reg_val);
+
+    return;
+}
+#endif
+void clock_dac0_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if(ClockEna == _clock_disable){
+		reg_val = power_clk_read(VDAC0_CTRL);
+		power_clk_write(VDAC0_CTRL, reg_val&(~(0x7<<3)));
+	}
+	else{
+		reg_val = power_clk_read(VDAC0_CTRL);
+		power_clk_write(VDAC0_CTRL, reg_val|(0x7<<3)|0xfffffc0);
+
+	}
+	return;
+}
+
+void clock_dac1_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if(ClockEna == _clock_disable){
+		reg_val = power_clk_read(VDAC1_CTRL);
+		power_clk_write(VDAC1_CTRL, reg_val&(~(0x7<<3)));
+	}
+	else{
+		reg_val = power_clk_read(VDAC1_CTRL);
+		power_clk_write(VDAC1_CTRL, reg_val|(0x1<<3)|0xfffffc0);
+	}
+	return;
+}
+
+enum disp0_pll_cfg {
+   target_freq       ,
+   ref_div           ,
+   fbdiv             ,
+   postdiv1          ,
+   postdiv2          ,
+   disp0_div         ,
+   disp0_clk0_div     ,
+   disp0_clk234_div   ,
+   disp0_clk6_div
+};
+//Display
+static const unsigned int disp0_pll_cfg[70][9] =
+{   //target_freq   ref_div  fbdiv  postdiv1  postdiv2  disp0_div  disp0_clk0_div  disp0_clk234_div  disp0_clk6_div
+    {  148500000,      1,      99,     4,       2,         2,          0,            0,               0 },          //
+    {  148500000,      1,      99,     4,       2,         2,          0,            0,               0 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+    {   74250000,      1,      99,     4,       2,         4,          2,            2,               4 },          //
+                                                                                                                			//
+    {  148351648,     13,    1125,     7,       1,         2,          2,            2,               4 },          // 6,
+    {   74175824,     13,    1125,     7,       1,         4,          2,            2,               4 },          // ,
+    {   74175824,     13,    1125,     7,       1,         4,          2,            2,               4 },          // ,
+    {   74175824,     13,    1125,     7,       1,         4,          2,            2,               4 },          // ,
+    {   74175824,     13,    1125,     7,       1,         4,          2,            2,               4 },          // ,
+                                                                                                                //
+    {   27000000,      1,      63,     7,       2,         4,          2,            2,               2 },          //
+    {   27000000,      1,      63,     7,       2,         4,          2,            2,               2 },          //
+    {   27027000,     20,    1802,     5,       4,         4,          2,            2,               2 },          //
+
+#if 1
+    {   13500000,      1,      63,     7,       2,         8,          2,            2,               4 },          //
+    {   13500000,      1,      63,     7,       2,         8,          2,            2,               4 },          //
+    {   13513500,     20,    1802,     5,       4,         8,          2,            2,               4 },        
+#else
+    {   13500000,      1,      63,     7,       2,         4,          2,            2,               4 },          //
+    {   13500000,      1,      63,     7,       2,         4,          2,            2,               4 },          //
+    {   13513500,     20,    1802,     5,       4,         4,          2,            2,               4 },          // ,
+#endif                                                                                                                //
+    {   31500000,      1,      84,     4,       2,         8,          0,            0,               0 },          // 00,
+    {   31500000,      1,      84,     4,       2,         8,          0,            0,               0 },          // 00,
+    {   35500000,      1,      71,     6,       1,         8,          0,            0,               0 },          // 00,
+    {   25200000,     1,    84,     5,       2,         8,          0,            0,               0 },
+    {   31500000,      1,      84,     4,       2,         8,          0,            0,               0 },          // 00,
+    {   31500000,      1,      84,     4,       2,         8,          0,            0,               0 },          // 00,
+    {   36000000,      1,      60,     5,       2,         4,          0,            0,               0 },          //
+    {   36000000,      1,      60,     5,       2,         4,          0,            0,               0 },          //
+    {   40000000,      1,      90,     6,       3,         3,          0,            0,               0 },          //
+    {   50000000,      1,      50,     4,       3,         2,          0,            0,               0 },          //
+    {   49500000,      1,      99,     4,       3,         4,          0,            0,               0 },          //
+    {   56250000,      1,      75,     4,       2,         4,          0,            0,               0 },          //
+    {   73250000,      4,     293,     4,       2,         3,          0,            0,               0 },          //
+                                                                                                                //
+    {   33750000,      1,      90,     4,       2,         8,          0,            0,               0 },          //
+                                                                                                                //
+    {   44900000,      6,     449,     5,       4,         2,          0,            0,               0 },          //
+    {   65000000,      1,      65,     4,       2,         3,          0,            0,               0 },          //
+    {   75000000,      1,      75,     4,       2,         3,          0,            0,               0 },          //
+    {   78750000,      2,     105,     4,       2,         2,          0,            0,               0 },          //
+    {   94500000,      1,      63,     4,       2,         2,          0,            0,               0 },          //
+    {  115500000,      1,      77,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {  108000000,      1,      72,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {   68250000,      2,      91,     4,       2,         2,          0,            0,               0 },          //
+    {   79500000,      1,      53,     4,       2,         2,          0,            0,               0 },          //
+    {  102250000,      6,     409,     4,       2,         2,          0,            0,               0 },          //
+    {  117500000,      3,     235,     4,       2,         2,          0,            0,               0 },          //
+    {  104250000,      2,     139,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {   71000000,      1,      71,     4,       2,         3,          0,            0,               0 },          //
+    {   83500000,      2,     167,     4,       2,         3,          0,            0,               0 },          //
+    {  106500000,      1,      71,     4,       2,         2,          0,            0,               0 },          //
+    {  122500000,      3,     245,     4,       2,         2,          0,            0,               0 },          //
+    {  146250000,      2,     195,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {  108000000,      1,      72,     4,       2,         2,          0,            0,               0 },          //
+    {  148500000,      1,      99,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  108000000,      1,      72,     4,       2,         2,          0,            0,               0 },          //
+    {  135000000,      1,      45,     4,       1,         2,          0,            0,               0 },          //
+    {  157500000,      2,     105,     4,       1,         2,          0,            0,               0 },          //
+                                                                                                                //
+    {   85500000,      1,      57,     4,       2,         2,          0,            0,               0 },          //
+    {  148250000,      8,     593,     6,       1,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  101000000,      3,     202,     4,       2,         2,          0,            0,               0 },          //
+    {  121750000,      6,     487,     4,       2,         2,          0,            0,               0 },          //
+    {  156000000,      1,      52,     4,       1,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {   88750000,      4,     355,     4,       2,         3,          0,            0,               0 },          //
+    {  106500000,      1,      71,     4,       2,         2,          0,            0,               0 },          //
+    {  136750000,      8,     547,     6,       1,         2,          0,            0,               0 },          //
+    {  157000000,      2,     157,     6,       1,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  162000000,      1,      81,     6,       1,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  119000000,      6,     476,     4,       2,         2,          0,            0,               0 },          //
+    {  146250000,      2,     195,     4,       2,         2,          0,            0,               0 },          //
+                                                                                                                    //
+    {  154000000,      2,     154,     6,       1,         2,          0,            0,               0 },           //
+
+    {   25175000,     20,    1007,     6,       1,         8,          0,            0,               0 },          //
+};
+
+void clock_disp0_setclock(CLOCK_DISP0_MODE mode_disp0)
+{
+    unsigned int   div_m               = 0;
+    unsigned int   div_fb              = 0;
+    unsigned int   div_fb_29_27;
+    unsigned int   div_fb_25_23;
+    unsigned int   div_fb_19_17;
+    unsigned int   div_fb_16_13;
+    unsigned int   div_fb_9_8;
+    unsigned int   div_fb_7_5;
+    unsigned int   div_fb_3_1;
+    unsigned int   data;
+
+    div_m  = (disp0_pll_cfg[mode_disp0][fbdiv] & 0xE00) >> 9;
+    div_fb_29_27 = (disp0_pll_cfg[mode_disp0][fbdiv] & 0x1C0) << 21;
+    div_fb_25_23 = (disp0_pll_cfg[mode_disp0][fbdiv] & 0x038) << 20;
+    div_fb_19_17 = (disp0_pll_cfg[mode_disp0][fbdiv] & 0x007) << 17;
+    div_fb_16_13 = (disp0_pll_cfg[mode_disp0][ref_div] & 0x00f) << 13;
+    div_fb_9_8   = (disp0_pll_cfg[mode_disp0][ref_div] & 0x030) << 4;
+    div_fb_7_5   = (disp0_pll_cfg[mode_disp0][postdiv1] & 0x007) << 5;
+    div_fb_3_1   = (disp0_pll_cfg[mode_disp0][postdiv2] & 0x007) << 1;
+
+    div_fb       = div_fb_29_27 | div_fb_25_23 | div_fb_19_17 | div_fb_16_13 | div_fb_9_8 | div_fb_7_5 | div_fb_3_1;
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) & 0xFFFFFFEF;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //disable tve clock, disp clock
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) & 0xFFFFFFFC;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //tve pll & divider reset
+
+    power_clk_write(PLL_TVE_PARA_Q, div_m);
+    power_clk_write(PLL_TVE_PARA_F, div_fb);    //tve pll parameter
+    data = power_clk_read(CLOCK_TVE_DIV_N ) & 0x0FFFF000;
+    power_clk_write(CLOCK_TVE_DIV_N, (data | (disp0_pll_cfg[mode_disp0][disp0_clk234_div] << 28) | (disp0_pll_cfg[mode_disp0][disp0_div] << 8) | (disp0_pll_cfg[mode_disp0][disp0_clk6_div] << 4) | disp0_pll_cfg[mode_disp0][disp0_clk0_div]));    //tve divider
+
+    udelay(2);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000001;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert tve pll reset
+
+    udelay(70);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000002;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert tve divider reset
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) | 0x00000010;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //enable tve clock, disp clock
+
+}
+
+enum disp1_pll_postdiv {
+   target_freq_disp1  ,
+   sys_div          ,
+   disp1_div         ,
+   disp1_clk0_div     ,
+   disp1_clk234_div   ,
+   disp1_clk6_div
+};
+
+static const unsigned int disp1_cfg[8][6] =
+{   //target_freq    sys_div  disp1_div  disp1_clk0_div  disp1_clk234_div  disp1_clk6_div
+    {   27000000,       10,        4,          2,            2,               2 },          //  576P
+    {   27000000,       10,        4,          2,            2,               2 },          //   480P
+    {   27000000,       10,        4,          2,            2,               4 },          //   PAL
+    {   27000000,       10,        4,          2,            2,               4 },          //    NTSL
+    {   27000000,       10,        4,          2,            2,               4 },          //   SECAM
+    {   27000000,       10,        4,          2,            2,               4 },          //   PAL_M
+    {   27000000,       10,        4,          2,            2,               4 },          //   PAL_N
+    {   27000000,       10,        4,          2,            2,               4 },          //    PAL_CN
+};
+void clock_disp1_setclock(CLOCK_DISP1_MODE mode_disp1)
+{
+    unsigned int   data;
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) & 0xFFFFFFDF;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //disable tve clock, disp clock
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) & 0xFFFFFFFD;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //tve divider reset
+
+    data = (power_clk_read(CLK_SRC_SEL ) & 0xFFF0FFFF) | 0x00050000;
+    power_clk_write(CLK_SRC_SEL, data);        //select sys pll as disp1 clock source
+
+    data = power_clk_read(CLOCK_TVE_DIV_N ) & 0xF0000FFF;
+    power_clk_write(CLOCK_TVE_DIV_N, (data | (disp1_cfg[mode_disp1][disp1_div] << 24) | (disp1_cfg[mode_disp1][disp1_clk6_div] << 20) | (disp1_cfg[mode_disp1][disp1_clk234_div] << 16) | (disp1_cfg[mode_disp1][disp1_clk0_div] << 12)));    //tve divider
+
+    data = power_clk_read(CLOCK_CLK_GEN_DIV ) & 0xFFFF03FF;
+    power_clk_write(CLOCK_CLK_GEN_DIV, (data | (disp1_cfg[mode_disp1][sys_div] << 10)) );    //cpu/sys  divider
+
+    udelay(10);
+
+    data = power_clk_read(CLOCK_PLL_SLEEP_N ) | 0x00000002;
+    power_clk_write(CLOCK_PLL_SLEEP_N, data);  //deassert tve divider reset
+
+    data = power_clk_read(CLOCK_PLL_CLK_EN ) | 0x00000020;
+    power_clk_write(CLOCK_PLL_CLK_EN, data);   //enable tve clock, disp clock
+
+}
+
+
+void clock_tve0_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<4)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<4));
+	}
+	return;
+}
+
+void clock_df_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<17)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<17));
+	}
+	return;
+}
+
+void clock_ahb2_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<19)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<19));
+	}
+	return;
+}
+
+void clock_video_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<23)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<23));
+	}
+	return;
+}
+
+void clock_cpu_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<30)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<30));
+	}
+	return;
+}
+
+void clock_cpusrc_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<31)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<31));
+	}
+	return;
+}
+
+void clock_vpb_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<28)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<28));
+	}
+	return;
+}
+
+void clock_vpbinput_enaclock(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val= 0;
+
+	if (ClockEna == _clock_disable){
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<29)));
+	}else{
+		reg_val = power_clk_read(CLOCK_PLL_CLK_EN);
+		power_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<29));
+	}
+	return;
+}
+#if 0
+void clock_hdmiset_clockmode(DISP_CLOCK_MODE DispMode,TMDS_CLOCK_MODE ClockMode)
+{
+    int iHdmiTmds,iTMDSDivEna;
+    unsigned int reg_val = 0;
+
+    //0.1 Gating HDMI_TMDS_CLK
+    reg_val = df_clk_read(CLOCK_TVE_DIV_N);
+    df_clk_write(CLOCK_TVE_DIV_N, reg_val&(~(0xf<<12)));
+
+    //0.2 Disable
+    reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+    df_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<6)));
+
+    //0.2 Config DIV
+    switch (DispMode) {
+    case 	_YUV_NTSC:
+    case	_YUV_PAL:
+    case    _YUV_480P:
+    case    _YUV_576P:
+        switch (ClockMode) {
+        case _1x_disp_clk:
+            iHdmiTmds=4;
+            reg_val = df_clk_read(CLOCK_TVE_DIV_N);
+            df_clk_write(CLOCK_TVE_DIV_N, reg_val|(0x4<<12));
+            break;
+        case _2x_disp_clk:
+            iHdmiTmds =2;
+            reg_val = df_clk_read(CLOCK_TVE_DIV_N);
+            df_clk_write(CLOCK_TVE_DIV_N, reg_val|(0x2<<12));
+            break;
+        case _4x_disp_clk:
+            iHdmiTmds =1;
+            reg_val = df_clk_read(CLOCK_TVE_DIV_N);
+            df_clk_write(CLOCK_TVE_DIV_N, reg_val|(0x1<<12));
+            break;
+        default:
+            ;
+        }
+        break;
+    case	_YUV_720P_50Hz:
+    case	_YUV_720P_60Hz:
+    case	_YUV_1080I_50Hz:
+    case	_YUV_1080I_60Hz:
+    case    _YUV_1080P_24Hz:
+    case 	_YUV_1080P_25Hz:
+    case 	_YUV_1080P_30Hz:
+        iHdmiTmds =4;
+        reg_val = df_clk_read(CLOCK_TVE_DIV_N);
+        df_clk_write(CLOCK_TVE_DIV_N, reg_val&(~(0xf<<12)));
+        df_clk_write(CLOCK_TVE_DIV_N, reg_val|(0x4<<12));
+        break;
+    default:
+        iHdmiTmds =2;
+        reg_val = df_clk_read(CLOCK_TVE_DIV_N);
+        df_clk_write(CLOCK_TVE_DIV_N, reg_val&(~(0xf<<12)));
+        df_clk_write(CLOCK_TVE_DIV_N, reg_val|(0x2<<12));
+
+    }
+
+    //0.3 Wait 1 us for stable
+    udelay(1);
+    //0.4 Enable
+    iTMDSDivEna=1;//CLOCK_REG_FMT(clock->iTMDSDivEna,6,1);
+    reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+    df_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<6));
+
+    return ;
+}
+
+void clock_ddcset_clockmode(DDC_CLOCK_MODE ClockMode)
+{
+    unsigned int reg_val=0;
+    int iDDCDiv;
+    //0 Gate Clock
+    iDDCDiv =0;//16/5
+    reg_val = df_clk_read(CLOCK_CLK_GEN_DIV);
+    df_clk_write(CLOCK_CLK_GEN_DIV, reg_val&(~(0x1f<<16)));
+
+    switch (ClockMode) {
+    case _ddc_clk_high:
+        iDDCDiv =10;    //70K
+        reg_val = df_clk_read(CLOCK_CLK_GEN_DIV);
+        df_clk_write(CLOCK_CLK_GEN_DIV, reg_val|(0xA<<16));
+        break;
+    case _ddc_clk_middle:   //60K
+        iDDCDiv =12;
+        reg_val = df_clk_read(CLOCK_CLK_GEN_DIV);
+        df_clk_write(CLOCK_CLK_GEN_DIV, reg_val|(0xC<<16));
+        break;
+    case _ddc_clk_low:     //50K
+        iDDCDiv =14;
+        reg_val = df_clk_read(CLOCK_CLK_GEN_DIV);
+        df_clk_write(CLOCK_CLK_GEN_DIV, reg_val|(0xE<<16));
+        break;
+    default:
+        ;
+    }
+
+    return;
+}
+
+void clock_cecset_clockmode(Cec_CLOCK_MODE ClockMode)
+{
+	unsigned int reg_val=0;
+
+	reg_val = df_clk_read(CLOCK_CLK_GEN_DIV);
+	reg_val &= (~0xff);
+
+	switch (ClockMode){
+		case _Cec_94P5M:
+		df_clk_write(CLOCK_CLK_GEN_DIV, reg_val|0x3);
+		break;
+		case _Cec_2P1M:
+		df_clk_write(CLOCK_CLK_GEN_DIV, reg_val|0xb3);
+		break;
+		case _Cec_1P48M:
+		df_clk_write(CLOCK_CLK_GEN_DIV, reg_val|0xfe);
+		break;
+	}
+
+	return;
+}
+
+typedef struct _AUDIO_PLL_CFG_ {
+    AUDIO_CLOCK_MODE ClockMode;
+    unsigned int Freq;
+    unsigned int HPD;
+    unsigned int Jitter;
+} AUDIO_PLL_CFG;
+AUDIO_PLL_CFG audio_pll;
+
+static AUDIO_PLL_CFG audio_pll_cfg []= {
+    {_AUDIO_192KHz		,	0x67f	,	1	,	0x5f370+0x90+0xa48	},
+    {_AUDIO_96KHz		,	1920	,	3	,	0x656d0	},
+    {_AUDIO_88_2KHz		,	1764	,	4	,	0x146d0	},
+    {_AUDIO_64KHz		,	1280	,	5	,	0x3d6d0	},
+    {_AUDIO_44_1KHz		,	882		,	8	,	0x146d0	},
+    {_AUDIO_48KHz		,	960		,	7	,	0x296d0	},
+    {_AUDIO_32KHz		,	640		,	11	,	0x156d0	},
+    {_AUDIO_24KHz		,	480		,	15	,	0x0b6d0	},
+    {_AUDIO_22_05KHz 	,	441		,	16	,	0x146d0	},
+    {_AUDIO_16KHz		,	320		,	23	,	0x16d0	},
+    {_AUDIO_12KHz		,	240		,	30	,	0xb6d0	},
+    {_AUDIO_11_025KHz	,	220		,	33	,	0x6a50	},
+    {_AUDIO_8KHz 		,	160		,	46	,	0x16d0	},
+
+};
+
+void clock_audio_setclock(AUDIO_CLOCK_MODE AudioClockMode)
+{
+    int SleepOrNot =0;
+    AUDIO_PLL_CFG *paudio_pll_cfg =NULL;
+    paudio_pll_cfg =&audio_pll_cfg[AudioClockMode];
+    //0.0 Get PLL Parameters
+
+    audio_pll.Freq = df_clk_read(CLOCK_AUD_FREQ);
+    audio_pll.HPD = df_clk_read(CLOCK_AUD_HPD);
+    audio_pll.Jitter = df_clk_read(CLOCK_AUD_JITTER);
+    if ((audio_pll.Freq==paudio_pll_cfg->Freq)&&
+            (audio_pll.HPD==paudio_pll_cfg->HPD)&&
+            (audio_pll.Jitter==paudio_pll_cfg->Jitter)) {
+        SleepOrNot =0;
+    } else {
+        SleepOrNot =1;
+    }
+
+    //0.1 Config PLL if needed
+    if (SleepOrNot) {
+        //1.0 Disable PLL output
+        //clock_audio_clockena(_clock_disable);	// lixun: for audio noise
+
+        //1.1 Config PLL
+        audio_pll.Freq =paudio_pll_cfg->Freq;
+        audio_pll.HPD=paudio_pll_cfg->HPD;
+        audio_pll.Jitter=paudio_pll_cfg->Jitter;
+
+        //1.2 Update The para to PLL
+        df_clk_write(CLOCK_AUD_FREQ, audio_pll.Freq);
+        df_clk_write(CLOCK_AUD_HPD, audio_pll.HPD);
+        df_clk_write(CLOCK_AUD_JITTER, audio_pll.Jitter);
+
+        //1.3 Sleep 200 us for Clock stable
+        udelay(50);
+
+        //1.4 Enable PLL output
+        clock_audio_clockena(_clock_enable);
+
+    }
+    return;
+
+}
+
+void clock_audio_clockena(CLOCK_ENA ClockEna)
+{
+    int iAudioClkEna;
+    unsigned int reg_val=0;
+
+    if (ClockEna == _clock_enable) {
+        iAudioClkEna = 1;//8/1
+        reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+        df_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<22));
+    } else {
+        iAudioClkEna = 0;
+        reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+        df_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<22)));
+    }
+
+    return;
+}
+
+//Xport
+void clock_xportInput_clocksel(int ClockSel) //0:SYS_CLK27 1:AV_CLK27
+{
+    int iXportClkSel;
+    unsigned int reg_val;
+
+    iXportClkSel = ClockSel & 0x1;
+
+    reg_val = df_clk_read(CLOCK_XPORT_CLK_SEL);
+    df_clk_write(CLOCK_XPORT_CLK_SEL, reg_val=iXportClkSel?1:0);
+    return;
+}
+
+//Video
+void clock_video_setClock(VIDEO_CLOCK_MODE ClockMode)
+{
+    unsigned int reg_val;
+    int iDivVideo;
+
+    //0 Gate Clock
+    iDivVideo =0;//CLOCK_PLL_AVS_DIV 0/4
+    reg_val = df_clk_read(CLOCK_PLL_AVS_DIV);
+    df_clk_write(CLOCK_PLL_AVS_DIV, reg_val&(~0xf));
+
+    switch (ClockMode) {
+    case _VIDEO_189M:
+        iDivVideo	=4;
+        reg_val = df_clk_read(CLOCK_PLL_AVS_DIV);
+        df_clk_write(CLOCK_PLL_AVS_DIV, reg_val|0x4);
+        break;
+    case _VIDEO_151_2M:
+        iDivVideo	=5;
+        reg_val = df_clk_read(CLOCK_PLL_AVS_DIV);
+        df_clk_write(CLOCK_PLL_AVS_DIV, reg_val|0x5);
+        break;
+    case _VIDEO_126M:
+        iDivVideo	=6;
+        reg_val = df_clk_read(CLOCK_PLL_AVS_DIV);
+        df_clk_write(CLOCK_PLL_AVS_DIV, reg_val|0x6);
+        break;
+    case _VIDEO_108M:
+        iDivVideo	=7;
+        reg_val = df_clk_read(CLOCK_PLL_AVS_DIV);
+        df_clk_write(CLOCK_PLL_AVS_DIV, reg_val|0x7);
+        break;
+    default:
+        printf("wrong mode set \n");
+    }
+
+    return;
+}
+
+//USB
+
+void power_usb0phy_down(POWER_MODE PowerMode)
+{
+    int iUSBPhyAnlogBlockPD;
+    unsigned int reg_val;
+
+    if (PowerMode==_clock_sleep) {
+        iUSBPhyAnlogBlockPD |=0x1;
+        reg_val = df_clk_read(CLOCK_USB_ULPI_BYPASS);
+        df_clk_write(CLOCK_USB_ULPI_BYPASS, reg_val|(0x1<<2));
+    } else {
+        iUSBPhyAnlogBlockPD &=0x2;
+        reg_val = df_clk_read(CLOCK_USB_ULPI_BYPASS);
+        df_clk_write(CLOCK_USB_ULPI_BYPASS, reg_val&(~(0x1<<2)));
+    }
+
+    return;
+
+}
+void power_usb1phy_down(POWER_MODE PowerMode)
+{
+    int iUSBPhyAnlogBlockPD;
+    unsigned int reg_val;
+
+    if (PowerMode==_clock_sleep) {
+        iUSBPhyAnlogBlockPD |=0x2;
+        reg_val = df_clk_read(CLOCK_USB_ULPI_BYPASS);
+        df_clk_write(CLOCK_USB_ULPI_BYPASS, reg_val|(0x2<<2));
+    } else {
+        iUSBPhyAnlogBlockPD &=0x1;
+        reg_val = df_clk_read(CLOCK_USB_ULPI_BYPASS);
+        df_clk_write(CLOCK_USB_ULPI_BYPASS, reg_val&(~(0x2<<2)));
+    }
+
+    return;
+
+}
+void power_audio_on(POWER_MODE PowerMode)
+{
+    unsigned int reg_val;
+
+    if (PowerMode==_clock_wake) {
+        reg_val = df_clk_read(CLOCK_AUD_POWER_ON);
+        df_clk_write(CLOCK_AUD_POWER_ON, (reg_val|0x1));
+    } else {
+        reg_val = df_clk_read(CLOCK_AUD_POWER_ON);
+        df_clk_write(CLOCK_AUD_POWER_ON, reg_val&(~(0x1)));
+    }
+
+    return;
+}
+void clock_usb1phy_bypassenable(void)
+{
+    int iUSBPhyBypass;
+    unsigned int reg_val;
+
+    iUSBPhyBypass =3;
+    reg_val = df_clk_read(CLOCK_USB_ULPI_BYPASS);
+    df_clk_write(CLOCK_USB_ULPI_BYPASS, reg_val|0x3);
+
+    return;
+
+}
+void clock_usb1phy_bypassdisable(void)
+{
+    int iUSBPhyBypass;
+    unsigned int reg_val;
+    iUSBPhyBypass =1;
+    reg_val = df_clk_read(CLOCK_USB_ULPI_BYPASS);
+    df_clk_write(CLOCK_USB_ULPI_BYPASS, reg_val|0x1);
+    return;
+
+}
+
+//Reset
+
+void clock_ddr_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+    int reset=0;
+
+    if (ResetOrSet==_do_reset) {
+        reset =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~0x1));
+    } else {
+        reset=1;
+        reg_val = df_clk_read(CLOCK_USB_ULPI_BYPASS);
+        df_clk_write(CLOCK_USB_ULPI_BYPASS, reg_val|0x1);
+    }
+
+    return;
+
+}
+
+void clock_audio_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+    int iUSBPhyBypass;
+
+    if (ResetOrSet==_do_reset) {
+        iUSBPhyBypass =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<3)));
+    } else {
+        iUSBPhyBypass=1;
+        reg_val = df_clk_read(CLOCK_USB_ULPI_BYPASS);
+        df_clk_write(CLOCK_USB_ULPI_BYPASS, reg_val|(0x1<<3));
+    }
+
+    return;
+
+}
+
+void clock_hdmi_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+    int iHDMIRst;
+
+    if (ResetOrSet==_do_reset) {
+        iHDMIRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<19)));
+    } else {
+        iHDMIRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<19));
+    }
+
+    return;
+}
+
+void clock_coda_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+    int iCodaRst;
+
+    if (ResetOrSet==_do_reset) {
+        iCodaRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<18)));
+    } else {
+        iCodaRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<18));
+    }
+
+    return;
+}
+
+void clock_usbphy_reset(CLOCK_RESET ResetOrSet)
+{
+    unsigned int reg_val;
+    int iUSBPhyRst;
+
+    if (ResetOrSet==_do_reset) {
+        iUSBPhyRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<17)));
+    } else {
+        iUSBPhyRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<17));
+    }
+
+    return;
+
+}
+
+void clock_vib_reset(CLOCK_RESET ResetOrSet)
+{
+    int iVIBRst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iVIBRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<16)));
+    } else {
+        iVIBRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<16));
+    }
+
+    return;
+
+
+}
+
+void clock_tve0_reset(CLOCK_RESET ResetOrSet)
+{
+    int iTVE0Rst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iTVE0Rst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<14)));
+    } else {
+        iTVE0Rst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<14));
+    }
+
+    return;
+
+
+}
+
+void clock_tve1_reset(CLOCK_RESET ResetOrSet)
+{
+    int iTVE1Rst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iTVE1Rst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<15)));
+    } else {
+        iTVE1Rst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<15));
+    }
+
+    return;
+
+
+}
+
+void clock_disp0_reset(CLOCK_RESET ResetOrSet)
+{
+    int iDisp0Rst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iDisp0Rst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<12)));
+    } else {
+        iDisp0Rst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<12));
+    }
+
+    return;
+
+}
+
+void clock_disp1_reset(CLOCK_RESET ResetOrSet)
+{
+    int iDisp1Rst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iDisp1Rst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<13)));
+    } else {
+        iDisp1Rst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<13));
+    }
+
+    return;
+
+}
+
+void clock_df_reset(CLOCK_RESET ResetOrSet)
+{
+    int iDFRst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iDFRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<11)));
+    } else {
+        iDFRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<11));
+    }
+
+    return;
+
+}
+
+void clock_gfx_reset(CLOCK_RESET ResetOrSet)
+{
+    int iDeintRst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iDeintRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<7)));
+    } else {
+        iDeintRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<7));
+    }
+
+    return;
+
+}
+
+void clock_video_reset(CLOCK_RESET ResetOrSet)
+{
+    int iVideoRst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iVideoRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<6)));
+    } else {
+        iVideoRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<6));
+    }
+
+    return;
+
+}
+
+void clock_crypto_reset(CLOCK_RESET ResetOrSet)
+{
+    int iSATARst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iSATARst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<5)));
+    } else {
+        iSATARst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<5));
+    }
+
+    return;
+
+}
+
+void clock_usb_reset(CLOCK_RESET ResetOrSet)
+{
+    int iUSBRst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iUSBRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<4)));
+    } else {
+        iUSBRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<4));
+    }
+
+    return;
+
+}
+void clock_ether_reset(CLOCK_RESET ResetOrSet)
+{
+    int iEtherRst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iEtherRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<2)));
+    } else {
+        iEtherRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<2));
+    }
+
+    return;
+
+}
+void clock_xport_reset(CLOCK_RESET ResetOrSet)
+{
+    int iXportRst;
+    unsigned int reg_val;
+    if (ResetOrSet==_do_reset) {
+        iXportRst =0;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val&(~(0x1<<1)));
+    } else {
+        iXportRst=1;
+        reg_val = df_clk_read(CLOCK_SOFT_RESET);
+        df_clk_write(CLOCK_SOFT_RESET, reg_val|(0x1<<1));
+    }
+
+    return;
+
+}
+
+void clock_video_clockena(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val;
+
+	if (ClockEna == _clock_enable) {
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val|(1<<23));
+	}
+	else{
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<23)));
+	}
+
+	return;
+}
+
+void clock_vib_clockena(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val;
+
+	if (ClockEna == _clock_enable) {
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val|(1<<28));
+	}
+	else{
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<28)));
+	}
+
+	return;
+}
+
+void clock_coda_clockena(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val;
+
+	if (ClockEna == _clock_enable) {
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val|(1<<16));
+	}
+	else{
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<16)));
+	}
+
+	return;
+}
+
+void clock_gfx_clockena(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val;
+
+	if (ClockEna == _clock_enable) {
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val|(1<<18));
+	}
+	else{
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<18)));
+	}
+
+	return;
+}
+
+void clock_crypto_clockena(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val;
+
+	if (ClockEna == _clock_enable) {
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val|(1<<20));
+	}
+	else{
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<20)));
+	}
+
+	return;
+}
+
+void clock_tms_clockena(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val;
+
+	if (ClockEna == _clock_enable) {
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val|(1<<6));
+	}
+	else{
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<6)));
+	}
+
+	return;
+}
+
+void clock_cec_clockena(CLOCK_ENA ClockEna)
+{
+	unsigned int reg_val;
+
+	if (ClockEna == _clock_enable) {
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val|(0x1<<26));
+	}
+	else{
+		reg_val = df_clk_read(CLOCK_PLL_CLK_EN);
+		df_clk_write(CLOCK_PLL_CLK_EN, reg_val&(~(0x1<<26)));
+	}
+
+	return;
+}
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/board/cavium/cnc1900/power_clock.h u-boot-2011.06/board/cavium/cnc1900/power_clock.h
